-- Specjalizacja dla Sipma Z224 --
-- Autor: Rockstar94 --
-- Data: 23.06.2015 --



z224 = {};

function z224.prerequisitesPresent(specializations)
return true;
end;

function z224:load(xmlFile)
	local klapa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapa#index"));
	if klapa ~= nil then
		self.klapa = klapa;
	end;
	
	local klapa1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapa1#index"));
	if klapa1 ~= nil then
		self.klapa1 = klapa1;
	end;

	local klapa2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapa2#index"));
	if klapa2 ~= nil then
		self.klapa2 = klapa2;
	end;
	
	local podbierak = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.podbierak#index"));
	if podbierak ~= nil then
		self.podbierak = podbierak;
	end;
	
	local Oslona2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Oslona2#index"));
	if Oslona2 ~= nil then
		self.Oslona2 = Oslona2;
	end;
	
	self.kolko = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kolko#index"));
	
	self.ropePanelAnimation = getXMLString(xmlFile, "vehicle.ropePanel#animationName");
	self.setRopePanel = SpecializationUtil.callSpecializationsFunction("setRopePanel");

	self.File = Utils.getFilename("Tekstury/hud.dds", self.baseDirectory);
	self.hudPoxX = 0.9095;
    self.hudPoxY = 0.86; 
    self.hudWidth = 0.13325;
    self.hudHeight = 0.0513825;
    self.HUDSipma = Overlay:new("HUDSipma", self.File, self.hudPoxX, self.hudPoxY, self.hudWidth, self.hudHeight);
    self.HUD = false;
	self.TotalBalesCount = 0;
	self.lastBaleCount = 0;
end;

function z224:delete()
	if self.HUDSipma ~= nil then
		self.HUDSipma:delete();
	end
end;

function z224:keyEvent(unicode, sym, modifier, isDown)
 end;
 
function z224:update(dt)		
	if self.isTurnedOn then
        self:setAnimationTime(1, 1);
    else
        self:setAnimationTime(1, 0);
    end;
	
	local nearestDistance = 1.5;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.klapa);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.przy_klapa = true;
		else
			self.przy_klapa = false;
		end;
		
    if self.przy_klapa then
		if InputBinding.hasEvent(InputBinding.klapa_sipma) then
			if self.animationParts[2].clipEndTime then
				self:setAnimationTime(2, self.animationParts[2].offSet);
			elseif self.animationParts[2].clipStartTime  then
				self:setAnimationTime(2, self.animationParts[2].animDuration);	
			end;
		end;
    end;
	
	if self.przy_klapa then
		if self.animationParts[2].clipStartTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("rozloz_sipma")), InputBinding.klapa_sipma);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("zloz_sipma")), InputBinding.klapa_sipma);
		end;
	end;	

	local nearestDistance = 2;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.klapa1);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.przy_klapa1 = true;
		else
			self.przy_klapa1 = false;
		end;
		
    if self.przy_klapa1 then
		if InputBinding.hasEvent(InputBinding.klapa_sipma) then
			if self.animationParts[4].clipEndTime then
				self:setAnimationTime(4, self.animationParts[4].offSet);
			elseif self.animationParts[4].clipStartTime  then
				self:setAnimationTime(4, self.animationParts[4].animDuration);	
			end;
		end;
    end;
	
	if self.przy_klapa1 then
		if self.animationParts[4].clipStartTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("rozloz2_sipma")), InputBinding.klapa_sipma);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("zloz2_sipma")), InputBinding.klapa_sipma);
		end;
	end;	

	local nearestDistance = 1.5;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.klapa2);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.przy_klapa2 = true;
		else
			self.przy_klapa2 = false;
		end;
		
    if self.przy_klapa2 then
		if InputBinding.hasEvent(InputBinding.klapa1_sipma) then
			if self.animationParts[5].clipEndTime then
				self:setAnimationTime(5, self.animationParts[5].offSet);
			elseif self.animationParts[5].clipStartTime  then
				self:setAnimationTime(5, self.animationParts[5].animDuration);	
			end;
		end;
    end;
	
	if self.przy_klapa2 then
		if self.animationParts[5].clipStartTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("rozloz2_sipma")), InputBinding.klapa1_sipma);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("zloz2_sipma")), InputBinding.klapa1_sipma);
		end;
	end;	
	
	if self.animationParts[2].clipStartTime and self:getIsActive(false) then
		self.isTurnedOn = false;
	end;
	
	if self.animationParts[2].clipStartTime and self:getIsActive(false) then
		if Input.isKeyPressed(Input.KEY_b) then
			g_currentMission:showBlinkingWarning(g_i18n:getText("info_sipma"), 2000);
		end;
	end;
	
	local nearestDistance = 1.5;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.podbierak);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.przy_podbierak = true;
		else
			self.przy_podbierak = false;
		end;
		
    if self.przy_podbierak then
		if InputBinding.hasEvent(InputBinding.podbierak_sipma) then
			if self.animationParts[3].clipEndTime then
				self:setAnimationTime(3, self.animationParts[3].offSet);
				self.isPickupLowered = false;
			elseif self.animationParts[3].clipStartTime  then
				self:setAnimationTime(3, self.animationParts[3].animDuration);	
				self.isPickupLowered = true;
			end;
		end;
    end;
	
	if self.przy_podbierak then
		if self.animationParts[3].clipStartTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("rozloz1_sipma")), InputBinding.podbierak_sipma);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("zloz1_sipma")), InputBinding.podbierak_sipma);
		end;
	end;

	if self:getIsActive() then
		if self.animationParts[3].clipEndTime then
			rotate(self.kolko, 2.5 * self.lastSpeedReal * self.movingDirection * dt ,0,0);
		end;
	end;
	
	if self.attacherVehicle ~= nil then
		self:setAnimationTime(6, self.animationParts[6].animDuration);
	else
		self:setAnimationTime(6, self.animationParts[6].startPosition);
	end;
	
	if self.przy_podbierak then
		if InputBinding.hasEvent(InputBinding.skladanie_sipma) then
			self:setRopePanel(not self.ropePanel);
		end;
		if self.ropePanel then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("open_sipma"), self.typeDesc), InputBinding.skladanie_sipma);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("close_sipma"), self.typeDesc), InputBinding.skladanie_sipma);
		end;
	end;
	
	if self.przy_klapa then
		if InputBinding.hasEvent(InputBinding.zaczep_sipma) then
			if self.animationParts[7].clipEndTime then
				self:setAnimationTime(7, self.animationParts[7].offSet);
			elseif self.animationParts[7].clipStartTime  then
				self:setAnimationTime(7, self.animationParts[7].animDuration);	
			end;
		end;
    end;
	
	if self.przy_klapa then
		if self.animationParts[7].clipStartTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("zaczep_rozloz_sipma")), InputBinding.zaczep_sipma);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("zaczep_zloz_sipma")), InputBinding.zaczep_sipma);
		end;
	end;	
	
	local nearestDistance = 1;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.Oslona2);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.przy_oslona = true;
		else
			self.przy_oslona = false;
		end;
		
    if self.przy_oslona then
		if InputBinding.hasEvent(InputBinding.oslona2_sipma) then
			if self.animationParts[8].clipEndTime then
				self:setAnimationTime(8, self.animationParts[8].offSet);
			elseif self.animationParts[8].clipStartTime  then
				self:setAnimationTime(8, self.animationParts[8].animDuration);	
			end;
		end;
    end;
	
	if self.przy_oslona then
		if self.animationParts[8].clipStartTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("rozloz_sipma")), InputBinding.oslona2_sipma);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("zloz_sipma")), InputBinding.oslona2_sipma);
		end;
	end;	
	
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.hud_sipma) then
			self.HUD = not self.HUD;
		end;
	end;

	if table.getn(self.bales) > self.lastBaleCount then
		self.TotalBalesCount = self.TotalBalesCount + 1;
		self.lastBaleCount = self.lastBaleCount + 1;
	elseif table.getn(self.bales) < self.lastBaleCount then
		self.lastBaleCount = self.lastBaleCount - 1;
	end;
	
	for k, bale in pairs(self.bales) do
		if bale.time > 0.5 then
			local sendTime = math.min(1, bale.time+dt/5000);
			self.setBaleTime(self, k, sendTime, true);
			done = false;
		end;
	end;
	
	if self.TotalBalesCount >= 250 then
		self.isTurnedOn = false;
		if self.animationParts[10].clipStartTime  then
			self:setAnimationTime(10, self.animationParts[10].animDuration);	
		end;
		if self:getIsActive() then
			g_currentMission:showBlinkingWarning(g_i18n:getText("info1_sipma"));
		end;
		if self.przy_klapa2 then
			if self.animationParts[5].clipEndTime then
				if Input.isKeyPressed(Input.KEY_o) then
					if self.animationParts[10].clipEndTime then
						self:setAnimationTime(10, self.animationParts[10].offSet);
					end;
					self.TotalBalesCount = 0;
					g_currentMission:addSharedMoney(-50);
				end;
			end;
		end;
	end;
	
	if self.przy_klapa2 then
		if self.animationParts[5].clipEndTime then
			if self.TotalBalesCount >= 250 then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("sipma_sznurek"), self.typeDesc), InputBinding.sznurek_sipma)
			end;
		end;
	end;
	
	if self.przy_klapa then
		if not self.isTurnedOn then
			if self.animationParts[2].clipEndTime then
				if InputBinding.hasEvent(InputBinding.sznurek_sipma) then
					if self.animationParts[9].clipEndTime then
						self:setAnimationTime(9, self.animationParts[9].offSet);
					elseif self.animationParts[9].clipStartTime  then
						self:setAnimationTime(9, self.animationParts[9].animDuration);	
					end;
				end;
			end;
		end;
    end;
	
	if self.przy_klapa then
		if self.animationParts[2].clipEndTime then
			if self.animationParts[9].clipStartTime then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("unload_sipma")), InputBinding.sznurek_sipma);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("unload_sipma")), InputBinding.sznurek_sipma);
			end;
		end;
	end;
end;

function z224:setRopePanel(isRopePanel)
	if isRopePanel then
		if self.ropePanelAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.ropePanelAnimation, -1, nil, true);
			self.ropePanel = true;
		end;
	else
		if self.ropePanelAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.ropePanelAnimation, 1, nil, true);
			self.ropePanel = false;
		end;
	end;
end;

function z224:mouseEvent(posX, posY, isDown, isUp, button)
end;

function z224:validateAttacherJoint(implement, jointDesc, dt)
return true;
end;

function z224:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then		
		local hud = getXMLBool(xmlFile, key.."#hud");
		if hud ~= nil then
			self.HUD = hud;
		end;
	end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function z224:getSaveAttributesAndNodes(nodeIdent)
	if self.HUD then
		hud = "true";
	else
		hud = "false";
	end;
	local attributes = string.format('hud="%s"', hud);
    return attributes,nodes;
end

function z224:draw()
	if self.HUD then
		self.HUDSipma:render();
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("hud_off"), self.typeDesc), InputBinding.hud_sipma);
		if self.TotalBalesCount >= 230 then
			setTextBold(true);
			setTextColor(1,0,0,1);
			totalBalesCountString = string.format("%d", self.TotalBalesCount);
			renderText(0.9592, 0.8789, 0.025, string.format(totalBalesCountString));
		else
			setTextBold(true);
			totalBalesCountString = string.format("%d", self.TotalBalesCount);
			renderText(0.9592, 0.8789, 0.025, string.format(totalBalesCountString));
		end;
	else
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("hud_on"), self.typeDesc), InputBinding.hud_sipma);	
	end;
end;